unit Spi00IN;

interface

uses
    //Dialogs,
    //SysUtils,
    Windows;

{$E .spi}

const
	SpiNotImplement		= -1;	// ̋@\̓CvgĂȂ
	SpiAllRight			= 0;	// I
	SpiAbort			= 1;	// R[obN֐0Ԃ̂œWJ𒆎~
	SpiUnknownFormat	= 2;	// m̃tH[}bg
	SpiOutOfOrder		= 3;	// f[^Ă
	SpiNoMemory			= 4;	// [mۏoȂ
	SpiMemoryError		= 5;	// [G[iLockoȂAj
	SpiFileReadError	= 6;	// t@C[hG[
	SpiReservedError	= 7;	// \
	SpiWindowError		= 7;	// JȂ (JG[R[h)
	SpiInternalError	= 8;	// G[
	SpiFileWriteError	= 9;	// ݃G[ (JG[R[h)
	SpiEndOfFile		= 10;	// t@CI[ (JG[R[h)


type
	// PictureInfo
	TPictureInfo = packed record
		Left:		Longint;
		Top:		Longint;
		Width:		Longint;
		Height:		Longint;
		x_Density:	Word;
		y_Density:	Word;
		colorDepth:	Smallint;
		hInfo:		HLOCAL;
	end;
	PPictureInfo = ^TPictureInfo;

	// ProgressCallback
	TProgressCallback = function(nNum, nDenom: Integer; lData: Longint): Integer; stdcall;

    PByte = ^Byte;

const
    { 摜wb_̃TCY }
    HeadBufSize = sizeof(BITMAPFILEHEADER) +sizeof(BITMAPINFOHEADER);
    // Plug-in APIo[W
    PlugInfo0 = '00IN';
    // Plug-inAo[Wy copyright
    PlugInfo1 = 'BMP to DIB filter';
    // \IȊgq ("*.JPG" "*.JPG;*.JPEG" Ȃ)
    PlugInfo2 = '*.bmp';
    // t@C`
    PlugInfo3 = 'BMP(*.BMP)';
    { Ƒ₷ꍇ GetPluginInfo ֐ɂ }

function IsSupportedEX(FileName: PChar; Data: PByte): LongBool;
function GetPictureInfoEx(var PictureInfo: TPictureInfo; Data: PByte): Integer;
function GetPictureEx(
Data: PByte; var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint;
DataSize: Longint
): Integer;

function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
function GetPictureInfo(
Buf: PChar; Len: Longint; Flag: Integer;
var PictureInfo: TPictureInfo
): Integer; stdcall;
function GetPicture(
Buf: PChar; Len: Longint; Flag: Integer;
var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;
function GetPreview(
Buf: PChar; Len: Longint; Flag: Integer;
var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;

exports
//	ConfigurationDlg,
	GetPluginInfo,
	IsSupported,
	GetPictureInfo,
	GetPicture,
	GetPreview;

implementation

// wb_đΉtH[}bgmF.
// ΉĂ̂Ȃ True, łȂ False Ԃ.
// FileName ̓t@C. ͂̎Ȃ nil ̏ꍇ.
// Data ̓t@C̐擪HoCgǂ݂񂾃obt@ւ̃|C^.
{ Data ̃TCYconst HeadBufSize. }
function IsSupportedEX(FileName: PChar; Data: PByte): LongBool;
var
    pBmpFile : ^BITMAPFILEHEADER;
    pBmpInfo : ^BITMAPINFOHEADER;
begin
    Result := False;

    pBmpFile := Pointer(Data);
    pBmpInfo := Pointer(PChar(Data) +sizeof(BITMAPFILEHEADER));

    if (  (pBmpFile.bfType = $4d42) {"BM"}
      and (pBmpFile.bfReserved1 = 0)
      and (pBmpFile.bfReserved2 = 0)
      and (pBmpInfo.biSize = $28)
      and (pBmpInfo.biPlanes = 1)
      and (pBmpInfo.biCompression = BI_RGB)
      and ( (pBmpInfo.biBitCount =  8)
         or (pBmpInfo.biBitCount = 24)
          )
        )
    then Result := True;
end;

// 摜t@C̏,G[R[hԂ.
// Data ̓t@C̐擪HoCgǂ݂񂾃obt@ւ̃|C^.
{ Data ̃TCYconst HeadBufSize. }
function GetPictureInfoEx(var PictureInfo: TPictureInfo; Data: PByte): Integer;
var
    pBmpInfo : ^BITMAPINFOHEADER;
    pDoc : PChar;
begin
    Result := SpiAllRight;
    pBmpInfo := Pointer(PChar(Data) +sizeof(BITMAPFILEHEADER));
    with PictureInfo, pBmpInfo^ do
    begin
        left       := 0;
        top        := 0;
        width      := biWidth;
        height     := biHeight;
        x_density  := 0;
        y_density  := 0;
        colorDepth := biBitCount;
//{$DEFINE DOCWRITE}
//{$IF Defined(DOCWRITE)}
        //BMP̃vOCȂ̂Ŗ{ɎgĂ̂s...
        //ؖ̂߂ɓhLgɏĂ
        hInfo      := LocalAlloc(LHND, 256);
        if (hInfo <> HLOCAL(nil)) then
        begin
            pDoc := LocalLock(hInfo);
            if (pDoc <> nil) then
            begin
                lstrcpy(pDoc, 'minispi sample');
                LocalUnlock(hInfo);
            end;
        end;
//{$ELSE}
//        hInfo      := HLOCAL(nil);
//{$IFEND}
    end;
end;

// 摜t@CDIBɕϊ,G[R[hԂ.
// Data ̓t@CC[W,TCY DataSize oCg.
function GetPictureEx(
Data: PByte; var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint;
DataSize: Longint
): Integer;
var
    pBmpFile : ^BITMAPFILEHEADER;
    pBmpInfo : ^BITMAPINFOHEADER;
    InfoSize : DWORD;
    Width : Longint;
    Height : Longint;
    Bit : WORD;
    LineSize : DWORD;
    ImgSize : DWORD;
    pInfo : ^BITMAPINFO;
    pBm : PByte;
    I : Integer;
    pSrc :PLongint;
    pDest :PLongint;
    ColCount :Integer;
begin
    Result := SpiAllRight;

    if (@ProgressCallback <> nil) then
    begin
        if (ProgressCallback(0, 1, lData) <> 0) then //0%
        begin
            Result := SpiAbort;
            Exit;
        end;
    end;

    pBmpFile := Pointer(Data);
    pBmpInfo := Pointer(PChar(Data) +sizeof(BITMAPFILEHEADER));

    with pBmpInfo^ do
    begin
        Width  := biWidth;
        Height := biHeight;
        Bit    := biBitCount;
    end;
    LineSize := (Width * (Bit div 8) +3) and (not 3); //4byteE
    ImgSize  := LineSize * DWORD(Abs(Height));
    InfoSize := sizeof(BITMAPINFOHEADER);
    if (Bit = 8) then InfoSize := Infosize +$400;


    HBInfo := LocalAlloc(LMEM_MOVEABLE, InfoSize);
    HBm    := LocalAlloc(LMEM_MOVEABLE, Imgsize);
    //ShowMessage(SysErrorMessage(GetLastError()));

    if ((HBInfo = HLOCAL(nil)) or (HBm = HLOCAL(nil))) then
    begin
        if (HBInfo <> HLOCAL(nil)) then LocalFree(HBInfo);
        if (HBm <> HLOCAL(nil)) then LocalFree(HBm);
        Result := SpiNoMemory;
        Exit;
    end;

    pInfo := LocalLock(HBInfo);
    pBm   := LocalLock(HBm);
    if ((pInfo = nil) or (pBm = nil)) then
    begin
        LocalFree(HBInfo);
        LocalFree(HBm);
        Result := SpiMemoryError;
        Exit;
    end;

    //HBInfoɂBITMAPINFO
    with pInfo.bmiHeader do
    begin
        biSize := sizeof(BITMAPINFOHEADER);
        biWidth := Width;
        biHeight := Height;
        biPlanes := 1;
        biBitCount := Bit;
        biCompression := BI_RGB;
        biSizeImage := ImgSize;
        biXPelsPerMeter := 0;
        biYPelsPerMeter := 0;
        biClrUsed := 0;
        biClrImportant := 0;
    end;
    if (Bit = 8) then
    begin
        pDest := @(pInfo.bmiColors);
        pSrc  := Pointer(PChar(Data) +sizeof(BITMAPFILEHEADER) +sizeof(BITMAPINFOHEADER));
        ColCount := pBmpInfo.biClrUsed;
        if (ColCount = 0) then ColCount := $100;
        for I:=1 to ColCount do
        begin
            pDest^ := pSrc^;
            Inc(pDest);
            Inc(pSrc);
        end;
    end;


    //HBmɂ̓rbg}bvf[^
    pDest := Pointer(pBm);
    pSrc  := Pointer(PChar(Data) +pBmpFile.bfOffBits);
    for I:=1 to (ImgSize div 4) do
    begin
        pDest^ := pSrc^;
        Inc(pDest);
        Inc(pSrc);
    end;

    LocalUnlock(HBInfo);
    LocalUnlock(HBm);

    if (@ProgressCallback <> nil) then
    begin
        if (ProgressCallback(1, 1, lData) <> 0) then //100%
        begin
            Result := SpiAbort;
            Exit;
        end;
    end;
end;


{ SPI֐ }
{
 ȉ͖肪ΎKvB
 HeadBufSize, PlugInfo0`3, `Ex֐B
}

// Plug-inɊւ𓾂
function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
var
    PlugInfo : PChar;
begin
    Result := 0;
    PlugInfo := nil;
    case InfoNo of
        0: PlugInfo := PlugInfo0;
        1: PlugInfo := PlugInfo1;
        2: PlugInfo := PlugInfo2;
        3: PlugInfo := PlugInfo3;
    end;

    if (PlugInfo <> nil) then
    begin
        lstrcpyn(Buf, PlugInfo, BufLen);
        Result := lstrlen(Buf);
    end;
end;


// WJ\(ΉĂ)t@C`ׂ
function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
var
    Data : PByte;
    Buf : array[0..HeadBufSize-1] of Byte;
    ReadBytes : DWORD;
begin
    Result := 0;
    if ((DW and $FFFF0000) = 0) then
    begin
        // DW̓t@Cnh
        if (ReadFile(DW, Buf, HeadBufSize, ReadBytes, nil) = False) then Exit;
        Data := @Buf;
    end
    else
    begin
        // DW̓obt@ւ̃|C^
        Data := Pointer(DW);
    end;

    // tH[}bgmF
    if (IsSupportedEx(FileName, Data)) then Result := 1;
end;

// 摜t@CɊւ𓾂
function GetPictureInfo(Buf: PChar; Len: Longint; Flag: Integer;
var PictureInfo: TPictureInfo): Integer; stdcall;
var
    Data : PByte;
    HeadBuf : array[0..HeadBufSize-1] of Byte;
    ReadBytes : DWORD;
    hf : THandle;
    FileName: PChar;
begin
    if ((flag and 7) = 0) then
    begin // Buf̓t@C
        hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
        if (hf = INVALID_HANDLE_VALUE) then
        begin
            Result := SpiFileReadError;
            Exit;
        end;
        try
            //SetFilePointer(hf, len, nil, FILE_BEGIN);
            if (ReadFile(hf, HeadBuf, HeadBufSize, ReadBytes, nil) = False) then
            begin
                Result := SpiFileReadError;
                Exit;
            end;
        finally
            CloseHandle(hf);
        end;
        Data := @HeadBuf;
        FileName := Buf;
    end
    else
    begin // Buf̓t@CC[Wւ̃|C^
        Data := Pointer(Buf);
        FileName := nil;
    end;

    // tH[}bgmF
    if (IsSupportedEx(FileName, Data) = False) then
    begin
        Result := SpiUnknownFormat;
        Exit;
    end;

    Result := GetPictureInfoEx(PictureInfo, Data);
end;

// 摜WJ
function GetPicture(Buf: PChar; Len: Longint; Flag: Integer;
var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;
var
    DataBuf : PByte;
    hData : HLOCAL;
    DataSize : DWORD;
    ReadBytes : DWORD;
    hf : THandle;
    FileName: PChar;
begin
    Result := SpiAllRight;
    hData := THandle(nil);

    if ((flag and 7) = 0) then
    begin // Buf̓t@C
        hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
        if (hf = INVALID_HANDLE_VALUE) then
        begin
            Result := SpiFileReadError;
            Exit;
        end;
        try
            //MacoCiɑΉȂ
            DataSize := GetFileSize(hf, nil);
            if (DataSize = $FFFFFFFF) then
            begin
                Result := SpiFileReadError;
                Exit;
            end;
            hData := LocalAlloc(LMEM_MOVEABLE, DataSize);
            if (hData = HLOCAL(nil)) then
            begin
                Result := SpiNoMemory;
                Exit;
            end;
            try
                DataBuf := LocalLock(hData);
                if (DataBuf = nil) then
                begin
                    Result := SpiMemoryError;
                    Exit;
                end;
                if (ReadFile(hf, DataBuf^, DataSize, ReadBytes, nil) = False) then
                begin
                    Result := SpiFileReadError;
                    Exit;
                end;
            finally
                if (Result <> SpiAllRight) then
                begin
                    //LocalUnlock(hData);
                    LocalFree(hData);
                end;
            end;
        finally
            CloseHandle(hf);
        end;
        FileName := Buf;
    end
    else
    begin // Buf̓t@CC[Wւ̃|C^
        DataBuf := Pointer(Buf);
        DataSize := Len;
        FileName := nil;
    end;

    // ꉞtH[}bgmF
    if (IsSupportedEx(FileName, DataBuf) = False)
    then Result := SpiUnknownFormat
    else Result := GetPictureEx(DataBuf, HBInfo, HBm, ProgressCallback, lData, DataSize);

    if (hData <> HLOCAL(nil)) then
    begin
        //LocalUnlock(hData);
        LocalFree(hData);
    end;
end;


// vr[EJ^O\p摜kWJ[eB
function GetPreview(
Buf: PChar; Len: Longint; Flag: Integer;
var HBInfo: HLOCAL; var HBm: HLOCAL;
ProgressCallback: TProgressCallback; lData: Longint
): Integer; stdcall;
begin
    Result:=SpiNotImplement;
end;

{
// Plug-inݒ_CAO\
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
    Result:=SpiNotImplement;
end;
}


end.


